CON
  _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
  _xinfreq = 5_000_000

  ' $AA = 1010_1010
  ' $77 = 0111_0111
  ' $EE = 1110_1110  
   
  'BMP_Addr  = $EE    
  'BMP_Addr = $77
  'BMP_Addr = %1110_1110
  'BMP_Addr = %1110_1111
  'BMP_Addr = 10_1110
  
  ' BMP-085 / BMP-180 Datasheet:  0xEF (read) and 0xEE (write)
  
  bmpAddr = $EE
  
  BMP_Read  = $EE
  'BMP_Write = $77
  BMP_Write = $EE
  'BMP_Write = $EF
    
  
  BMPSCL   = 26   
  SDA   = 27  

   
Var
  long AC1,AC2,AC3,AC4,AC5,AC6,B1,B2,MB,MC,MD             'E2Prom variables from BMP085

  long UT, UP

OBj
  I2C : "basic i2c driver"     
  term : "FullDuplexSerial"  'By Jeff Martin, Andy Lindsay, Chip Gracey      ren to pst
  umath : "umath"
   
PUB Main | mode, MSB, LSB, XLSB, oss, id, p, t, x, x1, x2, x3, b3, b4, b5, b6, b7

  waitcnt(cnt + clkfreq*4)
  term.start(31, 30, 0, 115200)        'Sets BaudRate for PST.    rem to pst
  
   
  I2C.initialize(BMPSCL)
  I2C.start(BMPSCL) 
                                     
  repeat      
                                                        
    AC1 := I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$AA)<<8
    AC1 |= I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$AB)

    AC2 := I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$AC)<<8
    AC2 |= I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$AD)
    
    ac3 := I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$AE)<<8
    ac3 |= I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$Af)                                                         
    
    ac4 := I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B0)<<8
    ac4 |= I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B1)
    
    ac5 := I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B2)<<8
    ac5 |= I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B3)
     
    ac6 := I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B4)<<8
    ac6 |= I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B5)
        
    b1 :=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B6)<<8
    b1 |=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B7) 
    
    b2 :=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B8)<<8
    b2 |=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$B9)
    
    mb :=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$BA)<<8                
    mb |=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$BB)
    
    mc :=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$BC)<<8
    mc |=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$BD)
     
    md :=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$BE)<<8
    md |=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$BF)                                        

    id :=  I2C.ReadByte(BMPSCL, BMP_Read, I2C#OneAddr|$D0)  ' 55     *** Should = 0x55
     
    waitcnt((clkfreq / 4) + cnt)
    term.tx(16) 
    
    term.str(string("AC1: "))
    term.hex(ac1, 2)
    term.str(string("  "))
    term.dec(ac1)  
    term.tx(13)
    term.str(string("AC2: "))
    term.hex(ac2, 2)
    term.str(string("  "))
    term.dec(ac2)    
    term.tx(13)
    term.str(string("AC3: "))
    term.hex(ac3, 2)
    term.str(string("  "))
    term.dec(ac3)    
    term.tx(13)
    term.str(string("AC4: "))
    term.hex(ac4, 2)
    term.str(string("  "))
    term.dec(ac4)    
    term.tx(13)
    term.str(string("AC5: "))
    term.hex(ac5, 2)
    term.str(string("  "))
    term.dec(ac5)    
    term.tx(13)
    term.str(string("AC6: "))
    term.hex(ac6, 2)
    term.str(string("  "))
    term.dec(ac6)    
    term.tx(13)                    

    term.str(string("B1: "))
    term.hex(b1, 2)
    term.str(string("  "))
    term.dec(b1)    
    term.tx(13)
    term.str(string("B2: "))
    term.hex(b2, 2)
    term.str(string("  "))
    term.dec(b2)    
    term.tx(13)

    term.str(string("MB: "))
    term.hex(mb, 2)
    term.str(string("  "))
    term.dec(mb)    
    term.tx(13)
    term.str(string("MC: "))
    term.hex(mc, 2)
    term.str(string("  "))
    term.dec(mc)    
    term.tx(13)
    term.str(string("MD: "))
    term.hex(md, 2)
    term.str(string("  "))
    term.dec(md)
    term.tx(13)        

    term.str(string("ID: "))
    term.hex(id, 2)
    term.str(string("  "))
    term.dec(id)    
    term.tx(13)     
                       
    
     ' // Read Uncompressed Temperature Value
    ' Write 0x2E into reg 0xF4, wait 4.5ms
    ' Read reg 0xF6 (MSB), 0xF7 (LSB)

        ' // Read Temperature
    I2C.WriteByte(BMPSCL, BMP_Write, $F4|I2C#OneAddr, $2E)
    waitcnt ((clkfreq / 220) + cnt)                  ' Pause 4.5 mS
    msb := I2C.Readbyte(BMPSCL, BMP_Read, $F6|I2C#OneAddr)
    lsb := I2C.Readbyte(BMPSCL, BMP_Read, $F7|I2C#OneAddr) 
    UT := msb<<8 + lsb

    term.str(string("UT: "))  
    term.hex(UT, 6)
    term.str(string("   "))
    term.dec(UT)
    term.tx(13)

        ' // Read Uncompressed Pressure Value
    ' Write 0x34+(oss<<6) into reg 0xF4, wait #.#ms
    ' Read reg 0xF6 (MSB), 0xF7 (LSB), 0xF8 (XLSB)
    
    ' // Read Pressure
    mode := 0
    I2C.WriteByte(BMPSCL, BMP_Write, $F4|I2C#OneAddr, $34+(mode<<6))       
    waitcnt ((clkfreq / 38) + cnt)                   ' Pause 26 mS
    MSB  := I2C.ReadByte(BMPSCL, BMP_Read, $F6|I2C#OneAddr)         
    LSB  := I2C.ReadByte(BMPSCL, BMP_Read, $F7|I2C#OneAddr)
    XLSB := I2C.ReadByte(BMPSCL, BMP_Read, $F8|I2C#OneAddr)      
    UP := (MSB<<16 + LSB<<8 + XLSB)>> (8 - mode)      
      
    term.str(string("UP: ")) 
    term.hex(UP, 6)
    term.str(string("   "))
    term.dec(UP)
    term.tx(13)        


    ' // Calculate True Temperature     
    x1 := ((ut - ac6) * ac5) ~> 15 
    x2 := (mc << 11) / (x1 + md)  
    b5 := x1 + x2
    t := (b5 + 8) ~> 4          
     
    term.str(string("Temperature: "))  
    term.dec(t)
    term.tx(13)
    
      term.dec(t/10)                            'BMP085 output
      term.tx(".")                                  'temp is C * 10
      term.dec(t//10)
      term.str(string("C "))   
      

    ' // Calculate True Pressure         
     b6 := b5 - 4000
     x1 := (b2 * ((b6 * b6) ~> 12)) ~> 11
     x2 := (ac2 * b6) ~> 11
     x3 := x1 + x2
     b3 := ((((ac1 << 2) + x3) << mode) + 2) ~> 2 

     x1 := (ac3 * b6) ~> 13
     x2 := (b1 * ((b6 * b6) ~> 12)) ~> 16
     x3 := ((x1 + x2) + 2) ~> 2   

     'b4 := (ac4 * (x3 + 32768)) >> 15                                             'unsigned 32 bit multiple
     b4 := umath.multdiv(ac4, (x3 + 32768), 32768)

     'b7 := (up - b3) * (50000 >> mode)                                            'unsigned 32 bit multiple
     'if b7 & $80000000
     '  p := (b7 / b4) << 1
     'else
     '  p := (b7 * 2) / b4
     p := umath.multdiv((up - b3), (100000 >> mode), b4)

     x := p ~> 8 
     x1 := x * x
     x1 := (x1 * 3038) ~> 16
     x2 := (-7357 * p) ~> 16
     p := p + ((x1 + x2 + 3791) ~> 4)

    term.tx(13)
    term.str(string("Pressure: ")) 
    term.dec(p)
    term.tx(13)
    
    
      term.dec(p)
      term.str(string("kPa, "))
     ' term.dec(0, ttime/(clkfreq/1000000))
      term.str(string("us"))
    
      